<?php

class libString
{
  /**
   * 随机字符串
   * @param int $length
   * @param bool $num
   * @param bool $lower
   * @param bool $upper
   * @return string
   */
  public static function rand ($length=5, $num=TRUE, $lower=TRUE, $upper=TRUE)
  {
    $str = '';
    $num && $str .= '0123456789';
    $lowercase && $str .= 'abcdefghijklmnopqrstuvwxyz';
    $uppercase && $str .= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $rand = substr(str_shuffle($str), -$length);
    return $rand;
  }
  /**
   * 字符串截取（单次）
   * @param $ld
   * @param $rd
   * @param $str
   * @return string
   */
  public static function sub ($ld, $rd, $str)
  {
    $start = strpos($str, $ld) + strlen($ld);
    $end = strpos($str, $rd, $start);
    $data = substr($str, $start, $end - $start);
    return $data;
  }
  /**
   * 字符串截取（批量）
   * @param $ld
   * @param $rd
   * @param $str
   * @return array
   */
  public static function subs ($ld, $rd, $str)
  {
    $data = [];
    $lLen = strlen($ld);
    $rLen = strlen($rd);
    $offset = 0;
    while ( ($start = strpos($str, $ld, $offset)) !== FALSE ) {
      $start += $lLen;
      $end = strpos($str, $rd, $start);
      $data[] = substr($str, $start, $end - $start);
      $offset = $end + $rLen;
    }
    return $data;
  }
  /**
   * 生成唯一ID
   * @return string
   */
  public static function uniqid ()
  {
    return md5(uniqid(rand(), true));
  }
}